package controllers

import (
	"context"
	"eta/eta_data_analysis/models"
	"eta/eta_data_analysis/services/ruizide"
	"eta/eta_data_analysis/utils"
	"github.com/beego/beego/v2/server/web"
)

type RzdController struct {
	web.Controller
}

// DealData
// @Title 解析睿咨得数据
// @Description 合同套餐列表
// @Param   DayFlag  query  int  false
// @Param   WeekFlag  query  int  false
// @Success 200 {object} company.GetUnusualRenewListGroupMonthResp
// @router /rz_deal_data [post]
func (this *RzdController) DealData() {
	br := new(models.BaseResponse).Init()
	defer func() {
		this.Data["json"] = br
		this.ServeJSON()
	}()
	var err error
	err = ruizide.ResolverNet(context.Background())
	if err != nil {
		utils.FileLog.Error("睿咨得数据处理失败 err:%v", err)
		br.Msg = "操作异常"
		br.ErrMsg = "操作异常，Err:" + err.Error()
		return
	}

	br.Ret = 200
	br.Success = true
	br.Msg = "操作成功"
}
