package models

import (
	"time"
)

type BaseFromCoalmineMapping struct {
	BaseFromCoalmineMappingId int       `orm:"column(base_from_coalmine_mapping_id);pk"`
	IndexName                 string    `description:"持买单量指标名称"`
	IndexCode                 string    `description:"持买单量指标编码"`
	CreateTime                time.Time `description:"时间"`
}

type BaseFromCoalmineJsmIndex struct {
	BaseFromCoalmineJsmIndexId int       `orm:"column(base_from_coalmine_jsm_index_id);pk"`
	IndexName                  string    `description:"持买单量指标名称"`
	IndexCode                  string    `description:"持买单量指标编码"`
	Exchange                   string    `description:"样本统计类别"`
	DealValue                  string    `description:"成交量"`
	DataTime                   string    `description:"数据日期"`
	Source                     string    `description:"来源"`
	Province                   string    `description:"省份"`
	Description                string    `description:"描述"`
	Unit                       string    `description:"单位"`
	Frequency                  string    `description:"频率"`
	CreateTime                 time.Time `description:"插入时间"`
	ModifyTime                 time.Time `description:"修改时间"`
}

type BaseFromCoalmineCompanyIndex struct {
	BaseFromCoalmineCompanyIndexId int       `orm:"column(base_from_coalmine_company_index_id);pk"`
	IndexName                      string    `description:"持买单量指标名称"`
	IndexCode                      string    `description:"持买单量指标编码"`
	DealValue                      string    `description:"成交量"`
	DataTime                       string    `description:"数据日期"`
	Source                         string    `description:"来源"`
	Province                       string    `description:"省份"`
	City                           string    `description:"城市"`
	GroupName                      string    `description:"集团名称"`
	Unit                           string    `description:"单位"`
	Frequency                      string    `description:"频率"`
	CreateTime                     time.Time `description:"插入时间"`
	ModifyTime                     time.Time `description:"修改时间"`
}

type SheetData struct {
	Name        string
	Rows        []Row
	Cols        []*Col
	MaxRow      int
	MaxCol      int
	Hidden      bool
	Selected    bool
}


type Row struct {
	Cells        []Cell
	Hidden       bool
	Height       float64
	OutlineLevel uint8
	isCustom     bool
}

type Col struct {
	Min             int
	Max             int
	Hidden          bool
	Width           float64
	Collapsed       bool
	OutlineLevel    uint8
	numFmt          string
}


type Cell struct {
	Value          string
}