package models

import "time"

// YongyiExcelData 涌益咨询的excel数据
type YongyiExcelIndex struct {
	//BaseFilePath   string
	//RenameFilePath string
	ClassifyName string `description:"指标目录"`
	ClassifySort int    `description:"指标目录排序号"`
	IndexName    string `description:"指标名称"`
	IndexCode    string `description:"指标编码"`
	Unit         string `description:"单位"`
	Sort         int    `description:"排序号"`
	Frequency    string `description:"频度"`
	TerminalCode string `description:"编码"`
	ExcelDataMap map[string]string
}

type BaseFromYongyiIndex struct {
	YongyiIndexId int `orm:"column(yongyi_index_id);pk"`
	ClassifyId    int
	IndexCode     string
	IndexName     string
	Frequency     string
	Unit          string
	Sort          int
	CreateTime    time.Time
	ModifyTime    time.Time
}

// BaseFromYongyiClassify 涌益咨询原始数据分类表
type BaseFromYongyiClassify struct {
	ClassifyId      int       `orm:"column(classify_id);pk"`
	ClassifyName    string    `description:"分类名称"`
	ParentId        int       `description:"父级id"`
	SysUserId       int       `description:"创建人id"`
	SysUserRealName string    `description:"创建人姓名"`
	Level           int       `description:"层级"`
	Sort            int       `description:"排序字段，越小越靠前，默认值：10"`
	ModifyTime      time.Time `description:"修改时间"`
	CreateTime      time.Time `description:"创建时间"`
}

type BaseFromYongyiData struct {
	YongyiDataId  int `orm:"column(yongyi_data_id);pk"`
	YongyiIndexId int
	IndexCode     string
	DataTime      string
	Value         string
	CreateTime    time.Time
	ModifyTime    time.Time
	DataTimestamp int64
}

type YongyiSheet struct {
	NamePrefix   string
	ClassifyName string
	Frequency    string
	Unit         string
}

type BaseEdbLibResponse struct {
	Ret     int
	Msg     string
	ErrMsg  string
	ErrCode string
	Data    interface{}
}
