package models

import "time"

type MysteelIndexResp struct {
	Ret     int    `json:"Ret"`
	Msg     string `json:"Msg"`
	ErrMsg  string `json:"ErrMsg"`
	ErrCode string `json:"ErrCode"`
	Data    struct {
		BaseFromMysteelChemicalIndexId    int64     `orm:"column(base_from_mysteel_chemical_index_id);pk"`
		BaseFromMysteelChemicalClassifyId int       `description:"分类id"`
		IndexCode                         string    `description:"指标编码"`
		IndexName                         string    `description:"指标名称"`
		Unit                              string    `description:"单位"`
		Source                            string    `description:"数据来源"`
		Frequency                         string    `description:"频度"`
		StartDate                         time.Time `description:"开始日期"`
		EndDate                           time.Time `description:"结束日期"`
		Describe                          string    `description:"指标描述"`
		UpdateWeek                        string    `description:"更新周期"`
		UpdateTime                        string    `description:"更新时间，多个时间点用英文,隔开"`
		UpdateTime2                       string    `description:"更新时间2"`
		SysUserId                         int       `description:"创建人id"`
		SysUserRealName                   string    `description:"创建人姓名"`
		FilePath                          string    `description:"文件存储路径"`
		MergeFilePath                     string    `description:"更新文件"`
		FileIndex                         int       `description:"文件索引"`
		MergeUpdateWeek                   string    `description:"合并文件的更新周"`
		UpdateDate                        string    `description:"更新日期"`
		CreateTime                        time.Time `description:"创建时间"`
		ModifyTime                        time.Time `description:"修改时间"`
	} `json:"Data"`
	Success bool `json:"Success"`
}
