package base_from_hisugar

type ChartResponse struct {
	Columns      []Column    `json:"columns"`
	Dataset      interface{} `json:"dataset"`
	IsCache      bool        `json:"isCache"`
	Status       string      `json:"status"`
	AppId        string      `json:"appId"`
	ResourceCode string      `json:"resourceCode"`
	ChartId      string      `json:"chartId"`
	NodeType     string      `json:"nodeType"`
	_Paramset    interface{} `json:"paramset"`
	WebapiParams interface{} `json:"webapiParams"`
	SceneName    string      `json:"sceneName"`
}

type Column struct {
	Name          string      `json:"name"`
	AliasName     string      `json:"aliasName"`
	Title         string      `json:"title"`
	FinalId       string      `json:"finalId"`
	TargetColumn  interface{} `json:"targetColumn"`
	AliasTitle    interface{} `json:"aliasTitle"`
	SuffixTitle   string      `json:"suffixTitle"`
	Index         int         `json:"index"`
	Expression    interface{} `json:"expression"`
	TableName     []string    `json:"tableName"`
	DsId          string      `json:"dsId"`
	AreaType      string      `json:"areaType"`
	AreaCode      string      `json:"areaCode"`
	DateFormatter interface{} `json:"dateFormatter"`
	Type          string      `json:"type"`
	IsAggExpr     bool        `json:"isAggExpr"`
	IsCalculate   bool        `json:"isCalculate"`
	IsEncrypt     bool        `json:"isEncrypt"`
	DataPackageId interface{} `json:"dataPackageId"`
	Fid           string      `json:"fid"`
	PanelId       string      `json:"panelId"`
	Sync          interface{} `json:"sync"`
}

type TargetColumn struct {
	Id            string        `json:"id"`
	Name          string        `json:"name"`
	OriName       string        `json:"oriName"`
	Alias         string        `json:"alias"`
	Title         string        `json:"title"`
	PinyinTitle   string        `json:"pinyinTitle"`
	Type          string        `json:"type"`
	Length        int           `json:"length"`
	Digits        int           `json:"digits"`
	Hide          bool          `json:"hide"`
	Expression    string        `json:"expression"`
	Index         int           `json:"index"`
	Dynamic       bool          `json:"dynamic"`
	RuleIds       interface{}   `json:"ruleIds"`
	Params        interface{}   `json:"params"`
	Sync          interface{}   `json:"sync"`
	ColDirs       []interface{} `json:"colDirs"`
	OriColAlias   interface{}   `json:"oriColAlias"`
	Description   interface{}   `json:"description"`
	CalColumn     bool          `json:"calColumn"`
	Position      bool          `json:"position"`
	DsId          string        `json:"dsId"`
	TableName     string        `json:"tableName"`
	TableType     string        `json:"tableType"`
	IsColumn      bool          `json:"isColumn"`
	ShowButton    bool          `json:"showButton"`
	DataPackageId interface{}   `json:"dataPackageId"`
	OriginName    string        `json:"originName"`
	Icon          string        `json:"icon"`
	GroupType     string        `json:"groupType"`
}

type Expression struct {
	IsGroup bool `json:"isGroup"`
}

type Dataset struct {
	DatasetId     string        `json:"datasetId"`
	DsId          string        `json:"dsId"`
	AppId         string        `json:"appId"`
	Tables        []Table       `json:"tables"`
	Relations     []interface{} `json:"relations"`
	Flow          Flow          `json:"flow"`
	Flowrelations []interface{} `json:"flowrelations"`
	Links         []interface{} `json:"links"`
}

type Table struct {
	Id                          string      `json:"id"`
	Name                        string      `json:"name"`
	Title                       string      `json:"title"`
	PinyinTitle                 interface{} `json:"pinyinTitle"`
	Type                        string      `json:"type"`
	Catalog                     interface{} `json:"catalog"`
	Schema                      interface{} `json:"schema"`
	OriginName                  interface{} `json:"originName"`
	Column                      interface{} `json:"column"`
	MetaColumn                  interface{} `json:"metaColumn"`
	Rownum                      int         `json:"rownum"`
	HideColumns                 interface{} `json:"hideColumns"`
	ColumnNames                 interface{} `json:"columnNames"`
	ColumnSync                  interface{} `json:"columnSync"`
	DataSqlSet                  interface{} `json:"dataSqlSet"`
	RefTables                   interface{} `json:"refTables"`
	ColumnFormatter             interface{} `json:"columnFormatter"`
	Rules                       interface{} `json:"rules"`
	Params                      interface{} `json:"params"`
	DataPrivileges              interface{} `json:"dataPrivileges"`
	DataPrivilegeRuleId         interface{} `json:"dataPrivilegeRuleId"`
	Sync                        interface{} `json:"sync"`
	FilterGroup                 interface{} `json:"filterGroup"`
	CollectPara                 interface{} `json:"collectPara"`
	CreateTime                  interface{} `json:"createTime"`
	DataPackageId               interface{} `json:"dataPackageId"`
	DataParamMappers            interface{} `json:"dataParamMappers"`
	ApiParams                   interface{} `json:"apiParams"`
	ExteralParams               interface{} `json:"exteralParams"`
	IsGlobalFusion              string      `json:"isGlobalFusion"`
	GlobalFusionSourceDsId      interface{} `json:"globalFusionSourceDsId"`
	GlobalFusionSourceTableName interface{} `json:"globalFusionSourceTableName"`
	GlobalFusionSourceShcema    interface{} `json:"globalFusionSourceShcema"`
	GlobalFusionSourceCatalog   interface{} `json:"globalFusionSourceCatalog"`
	ModelId                     interface{} `json:"modelId"`
	DsId                        interface{} `json:"dsId"`
	FilterNest                  bool        `json:"filterNest"`
	Etl                         bool        `json:"etl"`
}

type Flow struct {
	DsId     string  `json:"dsId"`
	Children []Child `json:"children"`
}

type Child struct {
	Eid   string `json:"eid"`
	Style Style  `json:"style"`
	Table Table  `json:"table"`
}

type Style struct {
	Top  string `json:"top"`
	Left string `json:"left"`
}

type WebapiParam struct {
	ParamName string `json:"paramName"`
	Type      string `json:"type"`
	Value     string `json:"value"`
}

type ParamSet struct {
	Search []Search      `json:"search"`
	Param  []interface{} `json:"param"`
}

type Search struct {
	Key       string `json:"key"`
	Value     string `json:"value"`
	Type      string `json:"type"`
	Separator string `json:"seperator"`
}

type ChartRequestSimple struct {
	Columns   []ColumnSimple `json:"columns"`
	SceneName string         `json:"sceneName"`
}

type ColumnSimple struct {
	Name       string `json:"name"`
	AliasName  string `json:"aliasName"`
	AliasTitle string `json:"aliasTitle"`
	Title      string `json:"title"`
}
